package cokr.xit.fims.cmmn.service.bean;

import java.util.List;

import javax.annotation.Resource;

import org.springframework.stereotype.Component;

import cokr.xit.foundation.AbstractComponent;
import cokr.xit.foundation.data.DataObject;

import cokr.xit.fims.cmmn.CrdnSttsHstry;
import cokr.xit.fims.cmmn.CrdnSttsHstryQuery;
import cokr.xit.fims.cmmn.dao.CrdnSttsHstryMapper;

/**단속 상태 이력 정보 관리 Bean
 *
 * <p>상세 설명:
 *
 * <pre>
 * ============ 변경 이력 ============
 * 2023-07-19	JoJH 최초 작성
 * ================================
 * </pre>
 */
@Component("crdnSttsHstryBean")
public class CrdnSttsHstryBean extends AbstractComponent {

	/** 단속 상태 이력 정보 DAO */
	@Resource(name = "crdnSttsHstryMapper")
	private CrdnSttsHstryMapper crdnSttsHstryMapper;

	/**지정한 조건에 따라 단속 상태 이력 목록을 조회하여 반환한다.
	 * @param req 단속 상태 이력 조회 조건
	 * @return 단속 상태 이력 목록
	 */
	public List<DataObject> getCrdnSttsHstryList(CrdnSttsHstryQuery req) {
		return crdnSttsHstryMapper.selectCrdnSttsHstryList(req);
	}

	/**지정한 조건에 따라 단속 상태 이력 객체들을 반환한다.
	 * @param req 단속 상태 이력 조회 조건
	 * @return 단속 상태 이력 객체 목록
	 */
	public List<DataObject> getCrdnSttsHstrys(CrdnSttsHstryQuery req) {
		return crdnSttsHstryMapper.selectCrdnSttsHstrys(req);
	}

	/**단속 ID에 따라 마지막 단속 상태 이력 객체를 반환한다.
	 * @param crdnId 단속 ID
	 * @return 단속 상태 이력 객체 목록
	 */
	public DataObject getCrdnSttsHstryInfo(String crdnId, String crdnSttsCd) {
		return crdnSttsHstryMapper.selectCrdnSttsHstryInfo(crdnId, crdnSttsCd);
	}

	/**단속 상태 이력 정보를 등록한다.
	 * @param crdnSttsHstry 단속 상태 이력
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	public boolean create(CrdnSttsHstry crdnSttsHstry) {
		if (crdnSttsHstry.getUseYn() == null) {
			crdnSttsHstry.setUseYn("Y");
		}

		return crdnSttsHstryMapper.insert(crdnSttsHstry);
	}

	/**단속 상태 이력 정보를 수정한다.
	 * @param crdnSttsHstry 단속 상태 이력
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	public boolean update(CrdnSttsHstry crdnSttsHstry) {
		return crdnSttsHstryMapper.update(crdnSttsHstry);
	}

	/**단속 상태 이력 정보를 삭제한다.
	 * @param crdnSttsHstry 단속 상태 이력
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	public boolean remove(CrdnSttsHstry crdnSttsHstry) {
		return crdnSttsHstryMapper.delete(crdnSttsHstry);
	}

	/**단속 대장의 상태 정보를 수정한다.
	 * @param excl 부과제외 대장
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	public boolean updateCrdn(CrdnSttsHstry crdnSttsHstry) {
		return crdnSttsHstryMapper.updateCrdn(crdnSttsHstry);
	}

	/**단속 상태 이력 정보를 등록하고, 단속 대장의 단속상태 정보를 수정한다.
	 * @param crdnSttsHstry 단속 상태 이력
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	public boolean createHstryUpdateCrdnSttsCd(CrdnSttsHstry crdnSttsHstry) {
		// 변수 선언
		boolean retSuccess = false;						// DB 처리 결과

		if (crdnSttsHstry.getUseYn() == null) {
			crdnSttsHstry.setUseYn("Y");
		}

		// 단속상태이력(TB_CRDN_STTS_HSTRY) 대장을 등록 한다.
		retSuccess = crdnSttsHstryMapper.insert(crdnSttsHstry);
		if (!retSuccess) {
			// 예외를 발생시켜서 오류메세지를 보내고 Database 롤백..
			throw new RuntimeException("단속상태이력 대장 등록에 실패하였습니다.");
		}

		// 단속(TB_CRDN) 대장을 수정 한다.
		retSuccess = crdnSttsHstryMapper.updateCrdn(crdnSttsHstry);
		if (!retSuccess) {
			// 예외를 발생시켜서 오류메세지를 보내고 Database 롤백..
			throw new RuntimeException("단속상태이력 정보 등록 중 오류가 발생하였습니다.");
		}

		return true;
	}

	/**단속 상태 이력 정보를 삭제하고, 하고 단속 대장의 단속상태 정보를 수정한다.
	 * @param crdnSttsHstry 단속 상태 이력
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	public boolean removeHstryUpdateCrdnSttsCd(String crdnId, String newCrdnSttsCd) {
		// 변수 선언
		boolean retSuccess = false;												// DB 처리 결과

		CrdnSttsHstry newCrdnSttsHstry = new CrdnSttsHstry();					// 단속상태이력(TB_CRDN_STTS_HSTRY) 신규 등록
		CrdnSttsHstry crdnSttsHstry = new CrdnSttsHstry();						// 단속상태이력(TB_CRDN_STTS_HSTRY)

		// 단속상태이력(TB_CRDN_STTS_HSTRY) 대장을 조회 한다.
		DataObject infoCrdnSttsHstry = crdnSttsHstryMapper.selectCrdnSttsHstryInfo(crdnId, "");	// 단속상태이력(TB_CRDN_STTS_HSTRY) 조회

		// 신규 단속상태코드가 있다면.. 단속상태이력(TB_CRDN_STTS_HSTRY) 대장을 등록 한다.
		if (!newCrdnSttsCd.equals("") ) {
			newCrdnSttsHstry.setCrdnId(infoCrdnSttsHstry.string("CRDN_ID"));					// 단속 ID
			newCrdnSttsHstry.setBfrSttsCd(infoCrdnSttsHstry.string("BFR_STTS_CD"));				// 이전 상태 코드
			newCrdnSttsHstry.setBfrSttsChgDt(infoCrdnSttsHstry.string("BFR_STTS_CHG_DT"));		// 이전 상태 변경 일시
			newCrdnSttsHstry.setCrdnSttsCd(newCrdnSttsCd);
			newCrdnSttsHstry.setUseYn("Y");

			retSuccess = crdnSttsHstryMapper.insert(newCrdnSttsHstry);
			if (!retSuccess) {
				// 예외를 발생시켜서 오류메세지를 보내고 Database 롤백..
				throw new RuntimeException("신규 단속상태이력 정보 등록 중 오류가 발생하였습니다.");
			}
		}

		// 단속(TB_CRDN) 대장의 단속 상태 코드를 수정 한다.
		crdnSttsHstry.setCrdnId(infoCrdnSttsHstry.string("CRDN_ID"));					// 단속 ID
		crdnSttsHstry.setCrdnSttsCd(infoCrdnSttsHstry.string("BFR_STTS_CD"));			// 상태 코드
		crdnSttsHstry.setCrdnSttsChgDt(infoCrdnSttsHstry.string("BFR_STTS_CHG_DT"));	// 상태 변경 일시

		retSuccess = crdnSttsHstryMapper.updateCrdn(crdnSttsHstry);
		if (!retSuccess) {
			// 예외를 발생시켜서 오류메세지를 보내고 Database 롤백..
			throw new RuntimeException("단속 대장에 단속상태코드 변경 중 오류가 발생하였습니다.");
		}

		// 단속상태이력(TB_CRDN_STTS_HSTRY) 대장을 등록 한다.
		newCrdnSttsHstry.setCrdnId(infoCrdnSttsHstry.string("CRDN_ID"));				// 단속 ID
		newCrdnSttsHstry.setBfrSttsCd(newCrdnSttsCd);									// 이전 상태 코드
		newCrdnSttsHstry.setBfrSttsChgDt(newCrdnSttsHstry.getCreatedAt());				// 이전 상태 변경 일시
		newCrdnSttsHstry.setCrdnSttsCd(infoCrdnSttsHstry.string("BFR_STTS_CD"));		// 단속 상태 코드
		newCrdnSttsHstry.setUseYn("Y");

		retSuccess = crdnSttsHstryMapper.insert(newCrdnSttsHstry);
		if (!retSuccess) {
			// 예외를 발생시켜서 오류메세지를 보내고 Database 롤백..
			throw new RuntimeException("이전 단속상태이력 정보 등록 중 오류가 발생하였습니다.");
		}

		return true;
	}

}
